<template>
    <div class="pa-4">
        <v-row>
            <v-col>
                <div class="subtitle-1 text--secondary">
                    {{ $t('user_', [$tc('address', 2)]) }}
                </div>
            </v-col>
        </v-row>

        <v-divider></v-divider>

        <v-row v-if="loading">
            <v-col class="d-flex align-center justify-center loader">
                <v-progress-circular indeterminate color="primary"></v-progress-circular>
            </v-col>
        </v-row>

        <v-row v-else>
            <v-col class="pa-0">
                <v-list>
                    <template
                        v-for="(address, index) in addresses"
                    >
                        <v-list-item three-line>
                            <v-list-item-content>
                                <v-list-item-title
                                    class="mb-2"
                                    v-if="address.id === defaultBilling || address.id === defaultShipping"
                                >
                                    <v-chip
                                        color="primary"
                                        text-color="white"
                                        label
                                        small
                                    >
                                        {{ address.id === defaultBilling ? $t('billing_address') : $t('shipping_address') }}
                                    </v-chip>
                                </v-list-item-title>
                                <v-list-item-title>
                                    {{ address.name }}, {{ address.company }}
                                </v-list-item-title>
                                <v-list-item-subtitle>
                                    {{ address.address_1 }}, {{ address.address_2 }}
                                </v-list-item-subtitle>
                                <v-list-item-subtitle>
                                    {{ address.city }}, {{ address.state }} {{ address.country }}, {{ address.postcode }}
                                </v-list-item-subtitle>
                                <v-list-item-subtitle>
                                    {{ address.mobile }}
                                </v-list-item-subtitle>
                            </v-list-item-content>
                        </v-list-item>

                        <v-divider
                            v-if="index < addresses.length - 1"
                            :key="index"
                        ></v-divider>
                    </template>
                </v-list>
            </v-col>
        </v-row>
    </div>
</template>

<script>

    import { mapMutations } from "vuex";

    export default {
        name: 'UserAddress',
        props: ['id'],
        data: () => ({
            loading: false,
            addresses: [],
            defaultBilling: undefined,
            defaultShipping: undefined,
        }),
        created() {
            this.fetchAddresses()
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            fetchAddresses() {
                this.loading = true;

                axios.get(`api/accounts/${this.id}/addresses`)
                    .then(({ data }) => {
                        this.addresses = data.data;
                        this.defaultBilling = data.meta.default_billing;
                        this.defaultShipping = data.meta.default_shipping;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    });
            }
        }
    }
</script>

<style scoped>
    .loader {
        min-height: 300px;
    }
</style>
